package Mason::Plugin::WithRole::Interp;
use Mason::PluginRole;

use Data::Dumper;
use File::Basename;
use Mason::Util qw(is_absolute mason_canon_path);
use Moose::Util;

#  qw(catdir catfile combine_similar_paths find_wanted first_index is_absolute json_decode mason_canon_path read_file taint_is_on touch_file uniq write_file);
#
#override _load_class_from_object_file => sub {
#    my $self = shift;
#    my ( $compc, $object_file, $path, $default_parent_path ) = @_;
#
#    my $flags = $self->_extract_flags_from_object_file($object_file);
#    my $parent_compc =
#         $self->_determine_parent_compc( $path, $flags )
#      || ( $default_parent_path eq '/' && $self->component_class )
#      || $self->load($default_parent_path);
#
#    my $with;
#    if ( exists( $flags->{with} ) ) {
#        my @args = ref($flags->{with}) ? @{$flags->{with}} : $flags->{with};
#
#        @args = map { 
#            if ( ref($_) ) {
#                $_;
#            }
#            else {
#                $_ = mason_canon_path( join( "/", dirname($path), $_ ) ) unless is_absolute($_);
#
#                my $comp = $self->_load_role($_);
#                $self->_comp_class_for_path($_);
#            }
#        } @args;
#
#        $with = Data::Dumper->new([\@args])->Indent(0)->Terse(1)->Dump;
#    }
#
#    my @lines;
#    push @lines, sprintf('package %s;', $compc);
#    push @lines, sprintf('use Moose; extends "%s";', $parent_compc) if $parent_compc;
#    #push @lines, sprintf('with @{%s};', $with) if $with;
#    push @lines, sprintf('do("%s"); die $@ if $@', $object_file);
#    #use IO::All;
#    #push @lines, sprintf('eval { %s }; die $@ if $@', io($object_file)->all);
#
#    my $code = join(" ", @lines);
#    warn $code;
#    ($code) = ( $code =~ /^(.*)/s ) if taint_is_on();
#    eval($code);
#    die $@ if $@;
#
#    $compc->_set_class_cmeta($self);
#    $self->modify_loaded_class($compc);
#};
#

after modify_loaded_class => sub {
    my $self = shift;
    my $compc = shift;

    my $object_file = $compc->cmeta->object_file;
    my $flags = $self->_extract_flags_from_object_file($object_file);
    #warn Dumper $flags;

    my @roles;
    if ( exists( $flags->{with_pp} ) ) {
        my @args = ref($flags->{with_pp}) ? @{$flags->{with_pp}} : ($flags->{with_pp});
        #warn Dumper \@args;
        Moose::Util::apply_all_roles($compc, @args);
    }
};

after modify_loaded_class => sub {
    my $self = shift;
    my $compc = shift;

    my $object_file = $compc->cmeta->object_file;
    my $flags = $self->_extract_flags_from_object_file($object_file);
    warn Dumper $flags;

    my @roles;
    if ( $flags->{with} ) {
        my @args = ref($flags->{with}) ? @{$flags->{with}} : ($flags->{with});

        for my $path (@args) {
            $path = mason_canon_path( join( "/", $compc->cmeta->dir_path, $path ) ) unless is_absolute($path);
            warn $path;
        }
    }
};

#method _load_role ($path) {
#    my $object_file = $self->_object_file_for_path($path);
#    my $source_file = $self->_source_file_for_path($path);
#    $self->_compile_to_file( $source_file, $path, $object_file );
#
#    my $compc = $self->_comp_class_for_path($path);
#    warn $compc;
#
#    local $self->{component_moose_class} = "Mason::Plugin::WithRole::Component::Moose::Role";
#    Class::MOP::load_class($self->component_moose_class);
#
#    my $code = sprintf( 'package %s; use Moose::Role; do("%s"); die $@ if $@', $compc, $object_file );
#    ($code) = ( $code =~ /^(.*)/s ) if taint_is_on();
#    eval($code);
#    die $@ if $@;
#
#    $compc;
#};

##after modify_loaded_class => sub {
##    my $self = shift;
##    my $compc = shift;
##
##    my $object_file = $compc->cmeta->object_file;
##    my $flags = $self->_extract_flags_from_object_file($object_file);
##    warn Dumper $flags;
##
###    my @roles;
###    if ( exists( $flags->{with} ) ) {
###        my $args = ref($flags->{with}) ? $flags->{with} : [\$flags->{with}];
###        for my $arg (@$args) {
###            next if ref($arg);
###            my $with = $arg;
###            $with = mason_canon_path( join( "/", $compc->cmeta->dir_path, $with ) )
###              if substr( $with, 0, 1 ) ne '/';
###            if ( my $comp = $self->_load_role($with) ) {
###                #push @roles, $comp;
###                $args = $with;
###            }
###            else {
###                die "could not load '$with' for with flag";
###            }
###        }
###    }
##
##    if ( $flags->{with} ) {
##        my @args = ref($flags->{with}) ? @{$flags->{with}} : $flags->{with};
##
##        @args = map { 
##            if ( ref($_) ) {
##                $_;
##            }
##            else {
##                $_ = mason_canon_path( join( "/", $compc->cmeta->dir_path, $_ ) ) unless is_absolute($_);
##
##                my $comp = $self->_load_role($_);
##                $self->_comp_class_for_path($_);
##            }
##        } @args;
##
##        use Data::Dumper;
##        warn Dumper \@args;
##        
##    warn "apply role";
##        warn Moose::Util::apply_all_roles($compc->meta, @args);
##    }
##
###    if (@roles) {
###        #for (@roles) {
###        #    #$_->meta->apply($compc->meta);
###        #    warn $compc;
###        #}
###        warn Moose::Util::apply_all_roles($compc, @roles) ? "good" : "fail";
###        #warn $compc->hello;
###    }
##};
#
#method _load_role ($path) {
#    my $object_file = $self->_object_file_for_path($path);
#    my $source_file = $self->_source_file_for_path($path);
#    $self->_compile_to_file( $source_file, $path, $object_file );
#
#    my $compc = $self->_comp_class_for_path($path);
#    warn $compc;
#
#    local $self->{component_moose_class} = "Mason::Plugin::WithRole::Component::Moose::Role";
#    Class::MOP::load_class($self->component_moose_class);
#
#    my $code = sprintf( 'package %s; use Moose::Role; do("%s"); die $@ if $@', $compc, $object_file );
#    ($code) = ( $code =~ /^(.*)/s ) if taint_is_on();
#    eval($code);
#    die $@ if $@;
#
#    $compc;
#};
#
##override _add_default_wrap_method => sub {
##    my $self = shift;
##    my $compc = shift;
##
##    if ( $compc->meta->isa("Moose::Meta::Role") ) {
##        warn "--";
##        warn $compc;
##    }
##    else {
##        warn "--";
##        warn $compc;
##        super();
##    }
##};
##
##override _superclass_signature => sub {
##    my $self = shift;
##    my $compc = shift;
##
##    if ( $compc->meta->can('superclasses') ) {
##        super();
##    }
##    else {
##        $compc;
##    }
##};

1;
