package Mason::Plugin::WithRole::Compilation;
use Mason::PluginRole;

use B::Hooks::EndOfScope;

use Mason::Util qw(is_absolute mason_canon_path json_decode);

around valid_flags => sub {
    my $orig = shift;
    my $self = shift;

    my $flags = $self->$orig;
    push @$flags, "with";
    push @$flags, "with_pp";
    push @$flags, "role";

    $flags;
};

#override _output_compiled_component => sub {
#    my $self = shift;
#
#    if ( $self->path =~ m/role/ ) {
#        return join(
#            "\n",
#            map { trim($_) } grep { defined($_) && length($_) } (
#                $self->_output_flag_comment, $self->_output_class_initialization,
#                $self->output_class_header,  $self->_output_global_declarations,
#                $self->_output_cmeta,        $self->_output_attributes,
#                $self->_output_class_block,  $self->_output_methods,
#                $self->output_class_footer,
#            )
#        ) . "\n";
#    }
#    else {
#        super();
#    }
#};

#override _output_class_initialization => sub {
#    my $self = shift;
#
#    require Mason::Plugin::WithRole::Mason;
#
#    return join(
#        "\n",
#        "our (\$_class_cmeta, \$m, \$_m_buffer, \$_interp);",
#        "BEGIN { ",
#        "local \$_interp = Mason::Interp->current_load_interp;",
#        #"\$_interp->component_moose_class->import;",
#        #"\$_interp->component_moose_class->import unless __PACKAGE__->meta->isa('Moose::Meta::Role');",
#        "\$_interp->component_moose_class->import unless __PACKAGE__->meta->isa('Moose::Meta::Role');",
#        "Mason::Plugin::WithRole::Mason->import if __PACKAGE__->meta->isa('Moose::Meta::Role');",
#        "\$_interp->component_import_class->import;",
#        "}",
#        "*m = \\\$Mason::Request::current_request;",
#        "*_m_buffer = \\\$Mason::Request::current_buffer;",
#
#        # Must be defined here since inner relies on caller()
#        "sub _inner { inner() }"
#    );
#};

#override _output_class_initialization => sub {
#    my $self = shift;
#
#    return join(
#        "\n",
#        "our (\$_class_cmeta, \$m, \$_m_buffer, \$_interp);",
#        "BEGIN { ",
#        "local \$_interp = Mason::Interp->current_load_interp;",
#        "\$_interp->component_moose_class->import;",
#        "warn '---'.\$_interp->component_moose_class;",
#        "\$_interp->component_import_class->import;",
#        "}",
#        "*m = \\\$Mason::Request::current_request;",
#        "*_m_buffer = \\\$Mason::Request::current_buffer;",
#
#        # Must be defined here since inner relies on caller()
#        "sub _inner { inner() }"
#    );
#};

#override _output_class_initialization => sub {
#    my $self = shift;
#
#    require Mason::Plugin::WithRole::Mason;
#
#    return join(
#        "\n",
#        "our (\$_class_cmeta, \$m, \$_m_buffer, \$_interp);",
#        "BEGIN { ",
#        "local \$_interp = Mason::Interp->current_load_interp;",
#        #"\$_interp->component_moose_class->import;",
#        #"\$_interp->component_moose_class->import unless __PACKAGE__->meta->isa('Moose::Meta::Role');",
#        "\$_interp->component_moose_class->import unless __PACKAGE__->meta->isa('Moose::Meta::Role');",
#        "Mason::Plugin::WithRole::Mason->import if __PACKAGE__->meta->isa('Moose::Meta::Role');",
#        "\$_interp->component_import_class->import;",
#        "}",
#        "*m = \\\$Mason::Request::current_request;",
#        "*_m_buffer = \\\$Mason::Request::current_buffer;",
#
#        # Must be defined here since inner relies on caller()
#        "sub _inner { inner() }"
#    );
#};

#around _output_class_initialization => sub {
#around output_class_footer => sub {
#    my $orig = shift;
#    my $self = shift;
#
#    my $flags = $self->interp->_extract_flags_from_object_file($self->interp->_object_file_for_path($self->path));
#    use Data::Dumper;
#    warn Dumper $flags;
#
#    my $code = $self->$orig(@_);
#    if ( $flags->{with} ) {
#        my @args = ref($flags->{with}) ? @{$flags->{with}} : $flags->{with};
#
##        @args = map { 
##            if ( ref($_) ) {
##                $_;
##            }
##            else {
##                $_ = mason_canon_path( join( "/", $self->dir_path, $_ ) ) unless is_absolute($_);
##                $self->interp->_comp_class_for_path($_);
##            }
##        } @args;
#        
#        #Moose::Util::apply_all_roles($self, @args);
#        $code .= sprintf('with @{%s};', Data::Dumper->new([\@args])->Indent(0)->Terse(1)->Dump);
#    }
#    warn "------$code";
#    $code;
#};

1;
